	INCLUDE EFR32MG12.inc		; CPU register definitions
	INCLUDE terminal.inc		; terminal function definitions		
	EXPORT	main

;-------------------------------------	; CODE segment in flash (ROM) 
	AREA    |.text|, CODE, READONLY
main	PROC				; main user code
	bl	Terminal_setup		; setup TeraTerm communication

loop					; periodic task starts here
	ldr	R0, =prompt1
	bl	WriteString		; print a prompt to get a number
	bl	ReadInt			; get user input
	mov	R1, R0			; save it in R1
	
	ldr	R0, =prompt2
	bl	WriteString		; print a prompt to get base
	bl	ReadInt			; get user input
	mov	R2, R0			; save it in R2
	
	movs	R4, #0			; digits counter
L1	udiv	R3, R1, R2		; R3 = R1/base
	mls	R0, R3, R2, R1		; R0 = digit
	push	{R0}			; save digit in stack
	adds	R4, #1			; update digits counter	
	orrs	R1, R3, R3		; R1 = R3 if non-zero
	bne	L1
	
L2	pop	{R0}			; retrieve digit from stack
	add	R0, #'0'		; ASCII conversion
	cmp	R0, #'9'
	ble	L3
	add	R0, #('A' - '0' - 10)
L3	bl	WriteChar
	subs	R4, #1
	bne	L2	
	bl	NewLine
	bl	NewLine

	b	loop			; repeat periodic task		
	ENDP

;-------------------------------------
prompt1	DCB	"Enter number: ", 0	
prompt2	DCB	"Enter base: ", 0

	ALIGN
;constW	DCD	15			; initialized 32-bit constant (=15) 
;constH DCW	23			; initialized 16-bit constant (=23)
;constB DCB	17			; initialized 8-bit constant  (=17)

	ALIGN
	END